﻿@model AEWeb.ViewModels.ApplicationPermission.ApplicationPermissionListViewModel
@using Microsoft.AspNetCore.Mvc.Localization
@inject IViewLocalizer Localizer
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
    ViewBag.Title = "List of permissions";
}

<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-lg-10">
        <h2>@Localizer["PageTitle"] @Model.Role.Name</h2>
        <small>@Localizer["PageDescription"]</small>
    </div>
    <div class="col-lg-2">

    </div>
</div>

<div class="wrapper wrapper-content">
    <div class="row">
        <div class="col-lg-12">

            <div class="ibox">
                <div class="ibox-title">

                    <form role="form" action="@Url.Action("AddPermissionInRole","Role")" method="post">
                        <div class="row">
                            <div class="col-md-4">
                                @(Html.Kendo().ComboBoxFor(m => m.SelectedPermissionId)
                                  .Placeholder("Type letters in role name or description")
                                  .DataTextField("name")
                                  .DataValueField("mnemonic")
                                  .HtmlAttributes(new { style = "width:100%;" })
                                  .Template("(#= mnemonic #) #= name #")
                                  .Filter(FilterType.Contains)
                                  .AutoBind(false)
                                  .MinLength(3)
                                  .DataSource(source =>
                                  {
                                      source.Read(read =>
                                      {
                                          read.Action("GetPermissionsBySearchJSON", "Role");
                                      })
                                      .ServerFiltering(true);
                                  })
                                )
                            </div>
                            @Html.HiddenFor(m => m.Role.Id)
                            <div class="col-md-2">
                                <button type="submit" class="btn btn-default btn-sm">Add Permission</button>
                            </div>
                            <div class="col-md-4"></div>
                            <div class="col-md-2">
                                <a asp-action="Index">Back to Roles</a>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="ibox-content">
                    <div class="table-responsive">
                        <div id="DataTables_Table_0_wrapper" class="dataTables_wrapper container-fluid dt-bootstrap4">

                            <div class="dataTables_info" id="DataTables_Table_0_info" role="status"
                                 aria-live="polite">
                                @Html.Raw(Model.MessageNumberEntries)
                            </div>

                            <table class="table table-striped table-bordered table-hover dataTables-example">
                                <thead>
                                    <tr>
                                        <th>
                                            Remove
                                        </th>
                                        <th>
                                            @Html.DisplayNameFor(model => model.Permissions[0].Mnemonic)
                                        </th>
                                        <th>
                                            @Html.DisplayNameFor(model => model.Permissions[0].Name)
                                        </th>
                                        <th>
                                            @Html.DisplayNameFor(model => model.Permissions[0].Description)
                                        </th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @if (Model.Permissions.Count > 0)
                                    {
                                        foreach (var item in Model.Permissions)
                                        {
                                            <tr>
                                                <td>
                                                    @if (item.Allowed)
                                                    {
                                                    <a asp-action="RemovePermissionInRole" 
                                                       asp-route-p="@item.Mnemonic"
                                                       asp-route-roleid="@Model.Role.Id"
                                                       class="text-decoration-none">
                                                        <i class="fa fa-trash-o"></i>
                                                    </a>
                                                    }
                                                </td>
                                                <td>
                                                    @Html.DisplayFor(modelItem => item.Mnemonic)
                                                </td>
                                                <td>
                                                    @Html.DisplayFor(modelItem => item.Name)
                                                </td>
                                                <td>
                                                    @Html.DisplayFor(modelItem => item.Description)
                                                </td>
                                            </tr>
                                        }
                                    }
                                    else
                                    {
                                        <tr>
                                            <td colspan="5" class="text-center">
                                                No permissions for role
                                            </td>
                                        </tr>
                                    }
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
